#ifndef INC_SVI05API
#define INC_SVI05API

#ifdef SVI05API_EXPORTS
#define SVI05API_API extern "C" __declspec(dllexport)
#else
#define SVI05API_API extern "C" __declspec(dllimport)
#endif

#ifdef SVI05API_EXPORTS
class __declspec(dllexport) CSVI05API {
public:
	CSVI05API(void);
};
#else
class __declspec(dllimport) CSVI05API {
public:
	CSVI05API(void);
};
#endif

// T|[gECuEG[R[h`
#define	SVI05API_RET_NORMAL				0x1
#define	SVI05API_RET_ERROR_DEVICE		0xe0000000
#define	SVI05API_RET_ERROR_DEVOPEN		0xf0000001
#define	SVI05API_RET_ERROR_MULTIOPEN	0xf0000002
#define	SVI05API_RET_ERROR_NOOPEN		0xf0000003
#define	SVI05API_RET_ERROR_PARAMETER	0xf0000004
#define	SVI05API_RET_ERROR_COM			0xf0000005
#define	SVI05API_RET_ERROR_NOIDLE		0xf0000006
#define	SVI05API_RET_ERROR_FMUPDATE_T	0xf0000007
#define	SVI05API_RET_ERROR_FPUPDATE_T	0xf0000008
#define	SVI05API_RET_ERROR_GSTS2_T		0xf0000009
#define	SVI05API_RET_ERROR_MDATA_T		0xf000000a
#define	SVI05API_RET_ERROR_SVI			0xf1000000

// SVI05API_GetStatus() p[^p`
#define SVI_STS_SUCCESS        0x0001  // I
#define SVI_STS_FRAMEPENDING   0x0002  // I (ۗt[/f[^)
#define SVI_STS_CAPCANCELED    0x0003  // I (Lv`~ꂽ)
#define SVI_STS_BUSY           0x0011  // rW[ŃR}hsłȂ
#define SVI_STS_RECOVERYMODE   0x0012  // Jo[[ĥ߃R}hsłȂ
#define SVI_STS_I2CACTIVE      0x0013  // I2CRg[ANeBu
#define SVI_STS_CMD_INVALID    0x0101  // R}hsł
#define SVI_STS_PRM_INVALID    0x0102  // p[^sł
#define SVI_STS_SEQ_INVALID    0x0103  // pPbg̔sV[PXsł
#define SVI_STS_CAM_POWER_OFF  0x0104  // JdOFFł
#define SVI_STS_I2C_ACKTIMEOUT 0x0601  // I2CŃX[uACKMł^CAEg
#define SVI_STS_I2C_PRETIMEOUT 0x0602  // I2CŃv^CAEg
#define SVI_STS_I2C_POSTTIMEOUT 0x0603 // I2CŃ|Xg^CAEg
#define SVI_STS_USB_ERROR      0x0C01  // USBʐMɃG[
#define SVI_STS_UPDATE_INVALID 0x0E01  // W[f[^sł
#define SVI_STS_FROMERS_ERROR  0x0E02  // tbV[̏Ɏs
#define SVI_STS_FROMWT_ERROR   0x0E03  // tbV[݂̏Ɏs
#define SVI_STS_INTERNAL_ERROR 0x0F01  // G[
#define SVI_STS_RESOURCE_ERROR 0x0F02  // \[XsďsłȂ

#define	SVI_STS_ERR_MASK			0xF00
#define	SVI05API_GETSTATUS_STS_OK	SVI_STS_SUCCESS

#define SVM_FPGAFW_ADRESS		0x0			// FPGAu[gf[^i[AhX
#define SVM_FX3FW_ADRESS		0x100000	// Fx3t@[EFAi[AhX

#define SVM_SETTINGINFO_SPARTAN_ADDRESS	0x1F0000
#define SVM_SETTINGINFO_ARTIX_ADDRESS	0xFF0000	// SVMSetting̊i[AhX
#define SVM_SPIMAX_ADRESS		0xFFFFFF	// SVMSetting̊i[AhX

#if 1 // 2015.04.16 V1.0.1.0 SVM-03/SVM-03UݑΉ
#define SVM03U_SETTINGINFO_ADRESS	0x1F0000	// SVM-03U:SVMSetting̊i[AhX
#define SVM03U_FPGAFW_ADRESS		0x80000		// SVM-03U:FPGAu[gf[^i[AhX
#define SVM03U_FX3FW_ADRESS			0x180000	// SVM-03U:Fx3t@[EFAi[AhX
#endif // 2015.04.16 V1.0.1.0 SVM-03/SVM-03UݑΉ

#define SVM_SSID_SPI			0xE7		// SSID-SPI-ROMւ̃ANZX[hw
#define SVM_SSID_EXTTARGET		0x00		// SSID-O^[QbgANZX[hw
#define SVM_SSID_FPGA			0x99		// SSIDFPGAANZX[hw
#define SVM_SSID_UARTDEBUG		0xDB		// SSIDUARTfobN[hw
#define SVM_SSID_NOSSID			0x42		// SSIDSPIpPbgɕtȂ[hw

#define SVMCTL_IF_I2CREAD1B		0
#define SVMCTL_IF_I2CWRITE		1
#define SVMCTL_IF_I2CREAD2B		2
#define SVMCTL_IF_SPIREAD		3
#define SVMCTL_IF_SPIWRITE		4
#define SVMCTL_IF_UPDATE		5
#define SVMCTL_IF_ROMREAD		6
#define SVMCTL_IF_REGREAD		7
#define SVMCTL_IF_REGWRITE		8
#define SVMCTL_IF_FX3READ		9
#define SVMCTL_IF_FX3WRITE		10
#define SVMCTL_IF_I2CREAD4B		11 // [23/08/10]
#define SVMCTL_IF_I2CREAD_LONG	20 // [21/03/22]
#define SVMCTL_IF_I2CWRITE_LONG	21
#define SVMCTL_IF_VERINFO		0xF0

#define SVM_FX3CMD_I2CREAD		SVMCTL_IF_I2CREAD1B		// FX3I2CRead̃R}h𔭍s
#define SVM_FX3CMD_I2CWRITE		SVMCTL_IF_I2CWRITE		// FX3I2CWritẽR}h𔭍s
#define SVM_FX3CMD_I2C2BREAD	SVMCTL_IF_I2CREAD2B		// FX3I2C2ByteRead̃R}h𔭍s
#define SVM_FX3CMD_SPIREAD		SVMCTL_IF_SPIREAD		// FX3SPIRead̃R}h𔭍s
#define SVM_FX3CMD_SPIWRITE		SVMCTL_IF_SPIWRITE		// FX3SPIWritẽR}h𔭍s
#define SVM_FX3CMD_FWUPDAT		SVMCTL_IF_UPDATE		// SPIROMɂFX3f[^Abvf[g
#define SVM_FX3CMD_FWUPDAT_CHECK SVMCTL_IF_ROMREAD		// SPIROMɂUpdate擾
#define SVM_FX3CMD_FX3VERSIONINFO	SVMCTL_IF_VERINFO	// FX3̃o[WmF

// SVI05API_Open() p[^p`
#define	SVI05API_APP_WHO_REC	1L
#define	SVI05API_APP_WHO_CTL	2L

SVI05API_API void  SVI05API_Init( void );
SVI05API_API DWORD SVI05API_Open(ULONG ulAppWho, int deviceIndex);
SVI05API_API DWORD SVI05API_OpenEx(ULONG ulAppWho, int deviceIndex, int boardIndex);
SVI05API_API DWORD SVI05API_I2CBlockWrite(ULONG ulSlaveAdr, ULONG ulSubdr, ULONG ulLen, PUCHAR pucSendBuf, int sAddrType);
SVI05API_API DWORD SVI05API_I2CBlockRead(ULONG  ulSlaveAdr, ULONG ulSubdr, ULONG ulLen, PUCHAR pucRcvBuf, int sAddrType);

SVI05API_API DWORD SVI05API_I2CDWRead(ULONG ulSlaveAdr, ULONG ulSubdr, ULONG ulLen, PUCHAR pucRcvBuf);


SVI05API_API DWORD SVI05API_GetBoardInfo(int boardType, int choosedDeviceIndex, char* boardInfo, size_t boardInfoSize, int* pBoardID);
SVI05API_API DWORD SVI05API_RestartSVM();
// [17/01/05]
SVI05API_API DWORD SVI05API_I2COneBlockWrite(ULONG ulSlaveAdr, ULONG ulLen, ULONG ulWriteMode, PUCHAR pucSendBuf);
SVI05API_API DWORD SVI05API_I2COneBlockRead(ULONG  ulSlaveAdr, ULONG ulLen, ULONG ulReadMode, PUCHAR pucRcvBuf);

SVI05API_API DWORD SVI05API_GetVersion( char *pcVerBuf );
SVI05API_API DWORD SVI05API_Close(ULONG ulAppWho);
SVI05API_API void  SVI05API_End( void );
SVI05API_API DWORD SVI05API_SPIRead (UCHAR ucCommdId, UCHAR ucSSId,ULONG ulAddress,ULONG ulLen,PUCHAR pucSendBuf);
SVI05API_API DWORD SVI05API_SPIWrite (UCHAR ucCommdId, UCHAR ucSSId,ULONG ulAddress,ULONG ulLen,PUCHAR pucSendBuf);
SVI05API_API DWORD SVI05API_SVMSettingRead (ULONG ulLen, PUCHAR pucRcvBuf);
SVI05API_API DWORD SVI05API_SVMSettingWrite (ULONG ulLen, PUCHAR pucRcvBuf);
SVI05API_API DWORD SVI05API_SVMVersionInfo (ULONG ulLen, PUCHAR pucRcvBuf);
SVI05API_API DWORD SVI05API_GetRevision(int* svm_03_revision, PUCHAR versionInfo, PUCHAR customCode);
SVI05API_API DWORD SVI05API_SVMSPIBootMemUpdate (ULONG ulAddress, ULONG ulLen, PUCHAR pucRcvBuf);
SVI05API_API DWORD SVI05API_SVMFX3Update (ULONG ulLen, PUCHAR pucRcvBuf);
SVI05API_API DWORD SVI05API_SVMFPGAUpdate (ULONG ulLen, PUCHAR pucRcvBuf);
SVI05API_API DWORD SVI05API_SVMSPIBootMemRead (ULONG ulAddress, ULONG ulLen, PUCHAR pucRcvBuf);
SVI05API_API DWORD SVI05API_SVMFX3BootMemRead (ULONG ulLen, PUCHAR pucRcvBuf);
SVI05API_API DWORD SVI05API_SVMFPGABootMemRead (ULONG ulLen, PUCHAR pucRcvBuf);
SVI05API_API DWORD SVI05API_SPIFpgaRead (UCHAR ucCommdId, UCHAR ucSSId,ULONG ulAddress,ULONG ulLen,PUCHAR pucRcvBuf);
SVI05API_API DWORD SVI05API_SPIFpgaWrite (UCHAR ucCommdId, UCHAR ucSSId,ULONG ulAddress,ULONG ulLen,PUCHAR pucSendBuf);

#if 1 // 2015.04.16 V1.0.1.0 SVM-03/SVM-03UݑΉ
SVI05API_API DWORD SVI05API_SVM03USettingRead (ULONG ulLen, PUCHAR pucRcvBuf);
SVI05API_API DWORD SVI05API_SVM03USettingWrite (ULONG ulLen, PUCHAR pucRcvBuf);
SVI05API_API DWORD SVI05API_SVM03UFX3Update (ULONG ulLen, PUCHAR pucRcvBuf);
SVI05API_API DWORD SVI05API_SVM03UFPGAUpdate (ULONG ulLen, PUCHAR pucRcvBuf);
SVI05API_API DWORD SVI05API_SVM03UFX3BootMemRead (ULONG ulLen, PUCHAR pucRcvBuf);
SVI05API_API DWORD SVI05API_SVM03UFPGABootMemRead (ULONG ulLen, PUCHAR pucRcvBuf);
#endif // 2015.04.16 V1.0.1.0 SVM-03/SVM-03UݑΉ

//SVI05API_API DWORD SVI05API_SettingRead (ULONG offset,  ULONG ulLen, PUCHAR pucRcvBuf);
//SVI05API_API DWORD SVI05API_SettingWrite (ULONG offset, ULONG ulLen, PUCHAR pucRcvBuf);
SVI05API_API DWORD SVI05API_Update (ULONG offset, ULONG ulLen, PUCHAR pucRcvBuf);

#endif
