// SVIctlDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "SVIctl.h"
#include "SVIctlDlg.h"
#include "DumpDialog.h"
//#include "SVMInfoDlg.h"
#if USE_USB_VERSION
#include "GetUSBVersion.h"
#endif
#include "SelBoardDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// 
char g_boardName[BOARD_NAME_SIZE];

// [15/05/25] SVIctlDlg.cpp ŕύX
int SVM_03_REVISION; // 0: SVM-03 / 1: SVM-03U
int SVM_MIPI_32B; // [18/07/30]
//int SVM_MIPI_BOARD;

/////////////////////////////////////////////////////////////////////////////
// CSVIctlDlg _CAO

CSVIctlDlg::CSVIctlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSVIctlDlg::IDD, pParent)
	, m_boardPower(TRUE)
	, m_subAddrType(0)
{
	//{{AFX_DATA_INIT(CSVIctlDlg)
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	pReadFileThread = NULL;
}

void CSVIctlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSVIctlDlg)
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_SVMSETTING, m_cButtonSetting);
	DDX_Control(pDX, ID_INIT, m_cButtonSFR);
	DDX_Control(pDX, ID_WRITE, m_cButtonWrite);
	DDX_Control(pDX, ID_READ, m_cButtonRead);
	DDX_Check(pDX, ID_BOARD_POWER, m_boardPower);
	DDX_Control(pDX, ID_RESTART_SVM, m_cButtonRestart);
	DDX_Radio(pDX, ID_BYTE_ADDRESS, m_subAddrType);
}

BEGIN_MESSAGE_MAP(CSVIctlDlg, CDialog)
	//{{AFX_MSG_MAP(CSVIctlDlg)
	ON_BN_CLICKED(ID_WRITE, OnWrite)
	ON_BN_CLICKED(ID_READ, OnRead)
	ON_BN_CLICKED(ID_INIT, OnSettingFileWrite)
		ON_WM_TIMER()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDOK, OnOK)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(ID_WORD_ADDRESS, &CSVIctlDlg::OnBnClickedWordAddress)
	ON_BN_CLICKED(ID_BOARD_POWER, &CSVIctlDlg::OnBnClickedBoardPower)
	ON_BN_CLICKED(ID_Debug, &CSVIctlDlg::OnBnClickedDebug)
	ON_BN_CLICKED(ID_Debug2, &CSVIctlDlg::OnBnClickedDebug2)
	ON_BN_CLICKED(IDC_BUTTON1, &CSVIctlDlg::OnBnClickedButton1)
	ON_BN_CLICKED(ID_RESTART_SVM, &CSVIctlDlg::OnBnClickedRestartSvm)
	ON_BN_CLICKED(ID_BYTE_ADDRESS, &CSVIctlDlg::OnBnClickedByteAddress)
	ON_BN_CLICKED(ID_DWORD_ADDRESS, &CSVIctlDlg::OnBnClickedDwordAddress)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSVIctlDlg bZ[W nh

int CSVIctlDlg::GetBoardName(char* boardName, int i)
{
	// Device ID
	int deviceID = 0; 

	m_sviUsbControl.GetBoardInfo(boardName, &deviceID);
	char buf[BOARD_NAME_SIZE];
	snprintf(buf, BOARD_NAME_SIZE, "%d: %s", i, boardName);
	strcpy(boardName, buf);

	// Main/Sub
	int isSubBoard = 0;
	{
		ULONG val = 0;
		m_sviUsbControl.ReadFPGARegister(0x00FE0008, &val);
		if(val == 0x01) isSubBoard = 1;
	}

	if(deviceID && deviceID < 100){
		char buf[BOARD_NAME_SIZE];
		snprintf(buf, BOARD_NAME_SIZE, "%s [ID=%d]", boardName, deviceID);
		strcpy(boardName, buf);
	}

	return 0;
}

int CSVIctlDlg::UpdateBoardInfo()
{
	// Main/Sub
	int isSubBoard = 0;
	{
		ULONG val = 0;
		m_sviUsbControl.ReadFPGARegister(0x00FE0008, &val);
		if(val == 0x01) isSubBoard = 1;
	}

	// Device ID
	int deviceID = 0;	
	m_sviUsbControl.GetBoardInfo(g_boardName, &deviceID);
	SVM_03_REVISION = 0;


	if(deviceID != 0 && deviceID < 16)
	{
		char buf[64];
		sprintf(buf, "[%d]", deviceID);
		strcat(g_boardName, buf);
	}
	return 0;
}
void CSVIctlDlg::UpdateRevisionFromCC(PUCHAR customCode, PUCHAR versionInfo)
{
	
	m_sviUsbControl.GetRevision(&SVM_03_REVISION, versionInfo, customCode);
	
	if (SVM_03_REVISION == -1){ // Unknown board
		SVM_03_REVISION = 20;
		CWnd* pWindow;
		pWindow = GetDlgItem(IDC_SVMINFO);
		if(pWindow) pWindow->EnableWindow(FALSE);
		pWindow = GetDlgItem(ID_BOARD_POWER);
		if(pWindow) pWindow->EnableWindow(FALSE);
		pWindow = GetDlgItem(IDC_SVMSETTING);
		if(pWindow) pWindow->EnableWindow(FALSE);
		strcpy(g_boardName, "Unknown board");
	//	m_cButtonSetting.SetWindowTextA("SVM-03 Setting");
	}

}

BOOL CSVIctlDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ

	//init@CeKp
	AppName = AfxGetAppName();
	IniFileName = "\\" + AppName + ".ini";
	TCHAR Path[MAX_PATH];
	GetCurrentDirectory(MAX_PATH,Path);
	IniFileName =  Path + IniFileName;
	CIniFileControl iniFile(AppName, IniFileName);

	CString windowTitleText = "SVMCtl";
	
	//	ID_SLAVE_ADDRESS
	CString slaveAddress = iniFile.GetString(INI_KEY_SLAVE_ADDRESS,DEFAULT_SLAVE_ADDRESS);
	this->SetDlgItemText(ID_SLAVE_ADDRESS,slaveAddress);

	// ID_SUB_ADDRESS
	CString subAddress = iniFile.GetString(INI_KEY_SUB_ADDRESS,DEFAULT_SUB_ADDRESS);
	this->SetDlgItemText(ID_SUB_ADDRESS,subAddress);

	// ID_VALUE
	CString value = iniFile.GetString(INI_KEY_VALUE,DEFAULT_VALUE);
	this->SetDlgItemText(ID_VALUE,value);

	// ID_READ_COUNTS
	CString readCounts = iniFile.GetString(INI_KEY_READ_COUNTS,DEFAULT_READ_COUNTS);
	this->SetDlgItemText(ID_READ_COUNTS,readCounts);

	// ID_WORD_ADDRESS
	int wordAddress = iniFile.GetInt(INI_KEY_WORD_ADDRESS,DEFAULT_WORD_ADDRESS);
	m_subAddrType = wordAddress;
	((CButton*)this->GetDlgItem(ID_BYTE_ADDRESS))->SetCheck(false);
	switch (m_subAddrType)
	{
	case 0:
		((CButton*)this->GetDlgItem(ID_BYTE_ADDRESS))->SetCheck(true);
		break;
	case 1:
		((CButton*)this->GetDlgItem(ID_WORD_ADDRESS))->SetCheck(true);
		break;
	case 2:
		((CButton*)this->GetDlgItem(ID_DWORD_ADDRESS))->SetCheck(true);
		break;
	default:
		((CButton*)this->GetDlgItem(ID_BYTE_ADDRESS))->SetCheck(true);
		break;
	}

	// [15/05/25] Get FW Version
	{
		strcpy(g_boardName, "(Unknown Device)");
		if(IsBoardSelected() == false) {
			windowTitleText += " -[No Device]";
			this->SetWindowTextA(windowTitleText);
			m_cButtonSetting.EnableWindow(FALSE); //
		}
		UCHAR buf[10];
		UCHAR versionInfo[4];

#define VIDEO_ID_MAX 8
		//  SVM o
		if(1){
			int maxIndex = 1;
			int curIndex = 0;
			int i;
			int boardType = 0, boardIdx = 0;
			int boardIdxList[VIDEO_ID_MAX] = {0};
			char boardName[VIDEO_ID_MAX][128];
			//int boardCnt = m_sviUsbControl.ScanBoard();
			for(i=0; i<VIDEO_ID_MAX; i++)
			{
				m_sviUsbControl.SetDeviceIndex(boardIdx);
				if(m_sviUsbControl.open() == false)
				{
					// [18/07/31]
					if(boardType == 0){
						// Switch SVM -> SVO
						boardType = 1;
						boardIdx = 0;
						m_sviUsbControl.SetBoardType(boardType);
						m_sviUsbControl.SetDeviceIndex(boardIdx);
						if(m_sviUsbControl.open() == false){
							break;
						}
					}else{
						break;
					}
				}
				m_sviUsbControl.close();
				boardIdxList[i] = (boardType << 8) | boardIdx;
				boardIdx ++;

				if(m_sviUsbControl.SVMVersionInfo(sizeof(versionInfo), versionInfo) == true){
					GetBoardName(boardName[i], i);

				}else{
					sprintf(boardName[i], "%d: Unknown board", i);
				}
				maxIndex = i+1;

			}

			// I
			if(maxIndex > 1){
				CSelBoardDlg dlg;
				for(i=0; i<maxIndex; i++){
					dlg.AppendBoardName(boardName[i]);
				}
									if(dlg.DoModal() == IDOK){
						curIndex = dlg.m_curBoardIdx;
					}
				}
			
			// [18/07/31] Modified
			if(curIndex > VIDEO_ID_MAX) curIndex = 0;
			m_sviUsbControl.SetBoardType(boardIdxList[curIndex] >> 8);
			m_sviUsbControl.SetDeviceIndex(boardIdxList[curIndex] & 0xFF);
		}

		Sleep(100);

		// SVM-03 / 03U o
		if(m_sviUsbControl.SVMVersionInfo(sizeof(versionInfo), versionInfo) == true)
		{
			char titleText[512];
			int fwVersion = versionInfo[0];
			int fpgaVersion = versionInfo[1];
			int fpgaVersion2 = versionInfo[2];

			// Custom Code
			UCHAR customCode[4] = {0,0,0,0}; // first -> fourth
			{
				UCHAR buf[4];
				if(!(fpgaVersion <= 1 && fpgaVersion2 == 0)){ // not v1.00
					m_sviUsbControl.GetCustomCode(customCode);
//					m_sviUsbControl.GetValue(0x08, 0x080000D0, buf, 4, FALSE, FALSE);
//					customCode[0] = buf[3];
//					m_sviUsbControl.GetValue(0x08, 0x080000D4, buf, 4, FALSE, FALSE);
//					customCode[1] = buf[3];
				}
			}
			UpdateBoardInfo();
			UpdateRevisionFromCC(customCode, versionInfo);

			sprintf(titleText, "%s [%s]", windowTitleText, g_boardName);

			// USB version
#if (USE_USB_VERSION)
			CGetUSBVersion usbVersion;
			// VID/PID [18/03/01] Currently not supported for VID 0x2FA3
			int bcdUsb = usbVersion.GetUSBVersion(SVM_PID, SVM_VID);
			if(bcdUsb > 100){
				char buf2[64];
				sprintf(buf2, "(USB%d.%d)", bcdUsb>>8, bcdUsb&0xFF);
				strcat(titleText, buf2);
			}else{
				strcat(titleText, "(USB?.?)");
				// Error
				MessageBoxA("Warning: Software could not get USB Version.");
			}
#endif
			this->SetWindowTextA(titleText);

			if(IS_SVO09() || IS_SVO_MIPI() ) 
			{
				m_cButtonSetting.EnableWindow(FALSE); //

				CWnd* pWindow;
				pWindow = GetDlgItem(ID_BOARD_POWER);
				if(pWindow) pWindow->EnableWindow(FALSE);
			}
			if( ! ((IS_SVM06()) && (fwVersion >= 123)) ){ //Not yet supported for DWORD sub address
				((CButton*)this->GetDlgItem(ID_DWORD_ADDRESS))->SetCheck(false);
				((CButton*)this->GetDlgItem(ID_DWORD_ADDRESS))->EnableWindow(false);
				
				if (m_subAddrType == 2){
					m_subAddrType = 0;
					((CButton*)this->GetDlgItem(ID_BYTE_ADDRESS))->SetCheck(true);
				}
			}
		}else{
			char titleText[512];
			sprintf(titleText, "%s +[No Device]", windowTitleText);
			this->SetWindowTextA(titleText);
			m_cButtonSetting.EnableWindow(FALSE); //

			m_cButtonSFR.EnableWindow(FALSE);
			m_cButtonRead.EnableWindow(FALSE);
			m_cButtonWrite.EnableWindow(FALSE);
			m_cButtonRestart.EnableWindow(FALSE);

			{
				CWnd* pWindow;
				pWindow = GetDlgItem(IDC_SVMINFO);
				if(pWindow) pWindow->EnableWindow(FALSE);

				pWindow = GetDlgItem(ID_BOARD_POWER);
				if(pWindow) pWindow->EnableWindow(FALSE);
			}
		}

	}
	

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

// CSV`̃p[X
int CSVIctlDlg::ParseCsv(CString strData, UCHAR* workBuf, ULONG bufSize/*vector<UCHAR> &work*/)
{
	if(strData.GetLength()==0) return 0;

		PTCHAR pStopstring;
	CString strWork;
	int pos = 0;
	int count = 0;
	PTCHAR string = strData.GetBuffer(strData.GetLength());
	PTCHAR spesLine = "\r\n";		//sPʂ̕
	PTCHAR spes = " ,\t\r\n";	//s̕
	PTCHAR tokenLine,token;
	strWork = "";
	// sPʂɕ
	tokenLine = _tcstok(string,spesLine);
	while(tokenLine != NULL)
	{
		TRACE("tokenLine = %s\n",tokenLine);
		if(tokenLine[0] =='#')
		{
			tokenLine = _tcstok(NULL,spes);
			continue;
		}
		strWork += tokenLine;
		strWork += ",";
		tokenLine = _tcstok(NULL,spesLine);
	}

	tokenLine = strWork.GetBuffer(strWork.GetLength());
	// s̕
	token = _tcstok(tokenLine,spes);
	while(token != NULL)
	{
		// t@CI[̐䕶Ή
		if(_tcslen(token) > 2 )
		{
			for(int i = 0 ; i < _tcslen(token);i++){
				if(!_istalnum(token[i]))
				{
					token[i] = '\0';
					break;
				}
			}
			if(_tcslen(token) < 2 )
				break;
		}
		int d = _tcstoul(token, &pStopstring, 16);
		
	if( count >= bufSize-1 )
			return 0;
	//	if(work.size() <= count)
				//		work.resize(count);
			workBuf[count] = d;
				count++;
				token = _tcstok(NULL, spes);
							}
			
			return count;
			}
			
void CSVIctlDlg::OnWrite()
{

	CButton *pCheck = (CButton *)GetDlgItem(ID_WORD_ADDRESS);
	CButton* pUse32bit = (CButton*)GetDlgItem(ID_DWORD_ADDRESS);
	UCHAR rcvBuf[1024];
	ULONG deviceAddr, regAddr;
	CString strText;
	char* temp;

	// IĂSVI-03{[hݒ肵܂
	if(IsBoardSelected() == false) return;

	// ݒl̎擾
	// Slave Address̎擾
	GetDlgItemText(ID_SLAVE_ADDRESS, strText);
	strText.TrimLeft();
	strText.TrimRight();
	if(strText.GetLength()==0)
	{
		AfxMessageBox(ID_MSG_ERR_NOINPUTSLAVE);
		return;
	}
	if(!CSVIctlDlg::Checkalnum((LPCTSTR)strText))
	{
		AfxMessageBox(ID_MSG_ERR_DATASLAVE);
		return;
	}

	deviceAddr = _tcstoul(strText, &temp, 16);

	// SubAddress̎擾
		GetDlgItemText(ID_SUB_ADDRESS,strText);
	strText.TrimLeft();
	strText.TrimRight();
	if(strText.GetLength()==0)
	{
AfxMessageBox(ID_MSG_ERR_NOINPUTSUB);
return;
	}
		if(!Checkalnum((LPCTSTR)strText))
		{
			AfxMessageBox(ID_MSG_ERR_NOINPUTSUB);
			return;
		}
		regAddr = _tcstoul(strText, &temp, 16);
	
	// Value̎擾
	GetDlgItemText(ID_VALUE,strText);
	strText.TrimLeft();
	strText.TrimRight();
	if(strText.GetLength()==0)
	{
		AfxMessageBox(ID_MSG_ERR_NOINPUTVALUE);
		return;
	}
		if(!Checkalnum((LPCTSTR)strText,true))
	{
		AfxMessageBox(ID_MSG_ERR_DATAVALUE);
		return;
	}

	if(deviceAddr == 0x08){
			ULONG ulVal;
			sscanf_s(strText, "%x", &ulVal);
			BYTE bVal[16];
		bVal[0] = (BYTE)((ulVal >> 24)&0xff);
			bVal[1] = (BYTE)((ulVal >> 16)&0xff);
			bVal[2] = (BYTE)((ulVal >>  8)&0xff);
			bVal[3] = (BYTE)((ulVal >>  0)&0xff);
		// JWX^̐ݒ
		if(!m_sviUsbControl.SetValue(deviceAddr, regAddr, bVal, 4, false))
		{
			AfxMessageBox(ID_MSG_ERR_WRITE);
			return;
		}
	}else{	
		// J}p[XArcvBufɐݒ
		int dataSize = ParseCsv(strText, rcvBuf, sizeof(rcvBuf));
		if(dataSize == 0) return;
			// JWX^̐ݒ
			if(!m_sviUsbControl.SetValue(deviceAddr, regAddr, rcvBuf, dataSize, m_subAddrType))
			{
				AfxMessageBox(ID_MSG_ERR_WRITE);
				return;
			}
		}
	}

void CSVIctlDlg::OnRead()
{
	CButton *pCheck = (CButton *)GetDlgItem(ID_WORD_ADDRESS);
	CButton* pUse32bit = (CButton*)GetDlgItem(ID_DWORD_ADDRESS);
	UCHAR rcvBuf[2048];
	ULONG deviceAddr, regAddr;
	ULONG cnt;

	CString strText;
	CString strRcv, strWork;
	char* temp;
	int i;

	// IĂSVI-03{[hݒ肵܂
	if(IsBoardSelected() == false) return;

	// Slave Address̎擾
	GetDlgItemText(ID_SLAVE_ADDRESS,strText);
	
	strText.TrimLeft();
	strText.TrimRight();
	if(strText.GetLength()==0)
	{
		AfxMessageBox(ID_MSG_ERR_NOINPUTSLAVE);
		return;
	}
	if(!Checkalnum((LPCTSTR)strText))
	{
		AfxMessageBox(ID_MSG_ERR_DATASLAVE);
		return;
	}
	deviceAddr = _tcstoul(strText, &temp, 16);

	// SubAddress̎擾
		GetDlgItemText(ID_SUB_ADDRESS,strText);
	strText.TrimLeft();
	strText.TrimRight();
	if(strText.GetLength()==0)
	{
		AfxMessageBox(ID_MSG_ERR_NOINPUTSUB);
		return;
	}
	if(!Checkalnum((LPCTSTR)strText))
	{
		AfxMessageBox(ID_MSG_ERR_DATASUB);
		return;
	}
	regAddr = _tcstoul(strText,&temp,16);

	BOOL Trans;
	cnt = GetDlgItemInt(ID_READ_COUNTS, &Trans, TRUE);
	if(!Trans)
	{
		AfxMessageBox(ID_MSG_ERR_DATAREADCOUNTS);
		return;
	}
	if(cnt <= 0)
	{
		AfxMessageBox(ID_MSG_ERR_NOINPUTREADCOUNTS);
		return;
	}

	if(cnt >= sizeof(rcvBuf)) {
		MessageBoxA("Size Over.", "Error", MB_ICONERROR);
		return;
	}
		
	int ret;
	ret = m_sviUsbControl.GetValue(deviceAddr,regAddr,&(rcvBuf[0]), cnt, m_subAddrType, true);
	if(!ret) // I2C Read
	{
		AfxMessageBox(ID_MSG_ERR_READ);
		return;
	}

	// 擾lJ}؂`֕ҏW
	if(cnt == 0){
		strRcv = "(No Data)";
	}else{
		for(i=0;i<cnt;i++)
			{
				strWork.Format("%02X", rcvBuf[i]);
			if(i==0)
				strWork = strWork;
			else if((i%16)==0) 
				strWork = ",\r\n" + strWork;
			else 
				strWork = "," + strWork;
			strRcv = strRcv + strWork;
		}
	}

	// Read Value֕\
	GetDlgItemText(ID_DUMP_VALUE,strWork);
	strWork = strWork + strRcv;
	strWork = strWork + "\r\n";
	SetDlgItemText(ID_DUMP_VALUE,strWork);

	// ŏIsɕ\
	CEdit* pEdit = (CEdit*)GetDlgItem(ID_DUMP_VALUE);
	pEdit->LineScroll(pEdit->GetLineCount());
}

void CSVIctlDlg::OnSettingFileWrite()
{
if(IsBoardSelected() == false) return;

	// obt@NA
	//rcvBuf.clear();

	CString AppName = AfxGetAppName();
	CString IniFileName = "\\" + AppName + ".ini";
	TCHAR Path[MAX_PATH];
	GetCurrentDirectory(MAX_PATH, Path);
	IniFileName =  Path + IniFileName;
	CIniFileControl iniFile(AppName, IniFileName);

	CString lastFileName = iniFile.GetString("SettingFileName", "");

	// t@C̓Ǎ
	char szFilter[] = STR_FILE_INIFILTER;
	// t@C̎ws
	CFileDialog dlg(TRUE, NULL, lastFileName,
						OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR,
						szFilter, NULL );
	dlg.m_ofn.lpstrTitle = "Open File";

	// nj{^ꂽ`FbN
	if( dlg.DoModal() == IDOK )
		strRecDataFileName = dlg.GetPathName();	// t@C擾
	else
		return;

	iniFile.SetString("SettingFileName", dlg.GetPathName());

	// t@C̎擾ƍXVbZ[Wo
	// t@Cǂݍ݁AJւ̐ݒ̃Xbhグ
	pReadFileThread = AfxBeginThread(ReadFileThread, this);
	// Xbhグ͕\ÂB
	MsgDialog.DoModal(ID_MSG_UPDATE_DATAWRITE);

}

void CSVIctlDlg::OnOK()
{
	// ^[ɂĉʂȂ悤ɂB
	//	CDialog::OnOK();
}

void CSVIctlDlg::OnTimer(UINT_PTR nIDEvent)
{
	// ǂݍݏ (gpȂ)
	if(nIDEvent == READTIMER)
			OnRead();
	CDialog::OnTimer(nIDEvent);
}

UINT CSVIctlDlg::ReadFileThread(LPVOID pMain)
{
	CSVIctlDlg* pMainWnd = (CSVIctlDlg*)pMain;
	CButton *pCheck = (CButton *)pMainWnd->GetDlgItem(ID_WORD_ADDRESS);
	int wordMode = pCheck->GetCheck();

	ULONG			deviceAddr;
	ULONG			regAddr;
	UCHAR*			rcvWorkBuff = NULL;
	UCHAR			lineBuf[16*1024];
	CString			strText;
	CString			strValue;
	
	char* temp;
	ULONG lwork;
	PTCHAR pStopstring;
	CString strWork, readValueText;
	// Flags
	int unit_f = 0;
	int wt_f = 0;
	int slave_f = 0;
	int read_f = 0;
	int unit = 16;
	int wt = 0;
	
	int fpos = 0;
	int bpos = 0;
		int i,j;

	char itemBuf[2560];
	vector<ULONG> ulItem;
	//ULONG ulItem[200];
	unsigned long ulFileLen;
	CFile file;

	pMainWnd->GetDlgItemText(ID_DUMP_VALUE, readValueText);

	if((pMainWnd->m_sviUsbControl).open() == false){
		AfxMessageBox(ID_MSG_ERR_NO_SVI03);
		goto readfile_end;
	}

	// ݒl̎擾
	// Slave Address̎擾
	pMainWnd->GetDlgItemText(ID_SLAVE_ADDRESS, strText);
	strText.TrimLeft();
	strText.TrimRight();
	if(strText.GetLength()==0)
	{
		AfxMessageBox(ID_MSG_ERR_NOINPUTSLAVE);
		goto readfile_end;
	}
	if(!pMainWnd->Checkalnum((LPCTSTR)strText))
	{
		AfxMessageBox(ID_MSG_ERR_DATASLAVE);
		goto readfile_end;
	}

	deviceAddr = _tcstoul(strText, &temp, 16);

	if(!file.Open(pMainWnd->strRecDataFileName ,
							CFile::modeRead |
							CFile::shareExclusive |
							CFile::typeBinary))
	{
		AfxMessageBox(ID_MSG_ERR_FILEOPEN);
		goto readfile_end;
	}

	// t@Cǂݍ(J}؂`)
	ulFileLen = file.GetLength();
	rcvWorkBuff = new UCHAR [ulFileLen + 2];
	file.Read(rcvWorkBuff, ulFileLen);
	rcvWorkBuff[ulFileLen++] = '\0';// [21/04/06] avoid fail for reading last line
		strValue = rcvWorkBuff;
	file.Close();

	// ɓǂݍ߂ȂG[
	if(strValue.GetLength()==0){
		AfxMessageBox(ID_MSG_ERR_FILEREAD);
		goto readfile_end;
	}

	int lineCnt = 0;
	// t@ĆI2CM
	while(fpos < ulFileLen)
	{
		// 1s擾
		for(bpos=0; fpos < ulFileLen; fpos++)
		{
			if(rcvWorkBuff[fpos] == '\r' && rcvWorkBuff[fpos+1] == '\n')
			{
				lineBuf[bpos++] = '\0';
				lineCnt ++;
				fpos+=2;
				break;
			}
			else if (rcvWorkBuff[fpos] == '\r' || rcvWorkBuff[fpos] == '\n' || rcvWorkBuff[fpos] == '\0') // [21/04/06] avoid fail for reading last line
			{
				lineBuf[bpos++] = '\0';
				lineCnt++;
				fpos += 1;
				break;
			}
			lineBuf[bpos++] = rcvWorkBuff[fpos];
		}
		// Rgsi擪J'#'';'jXLbv
		if(lineBuf[0] == '#' || lineBuf[0] == ';' || lineBuf[0] == '\0' || lineBuf[0] == '/') continue;
		// 1s
		ulItem.clear();
		for(i=j=0;i<bpos;i++)
		{
			// s̃ACeo
			if( lineBuf[i] == ','  ||
					lineBuf[i] == ' '  || 
					lineBuf[i] == '\t' ||
					lineBuf[i] == ';'  ||
					lineBuf[i] == '#'  ||
					lineBuf[i] == '\0')
			{

				char* temp;
				// 䕶i"UNIT","WT","SLAVE"j琧䏈s
				itemBuf[j++] = '\0';

				if(_tcsncmp(itemBuf, "UNIT", 4) == 0) unit_f = 1;
				else if(_tcsncmp(itemBuf, "BYTE", 4) == 0) wordMode = 0;
				else if(_tcsncmp(itemBuf, "WORD", 4) == 0) wordMode = 1;
				else if(_tcsncmp(itemBuf, "DWORD", 4) == 0) wordMode = 2;
				else if(_tcsncmp(itemBuf, "wt", 2) == 0) wt_f = 1;
				else if(_tcsncmp(itemBuf, "WT", 2) == 0) wt_f = 1;
				else if(_tcsncmp(itemBuf, "SLAVE", 5) == 0) slave_f = 1;
				else if(_tcsncmp(itemBuf, "READ", 4) == 0) read_f = 1;
								else{
					if(unit_f != 0){
						unit = strtol(itemBuf, &temp, 10);
						unit_f = 0;
					}else if(wt_f != 0){
						wt = strtol(itemBuf, &temp, unit); // [17/12/06] unit should be 10 but this inherites old version...
						Sleep(wt);
						wt_f = 0;
					}else if(slave_f != 0){
						deviceAddr = strtol(itemBuf, &temp, unit);
						slave_f = 0;
					}else if(read_f != 0){
						if(ulItem.size() == 1){ // 2nd content
							ulItem.push_back(strtoul(itemBuf, &temp, 10));
						}else{
							ulItem.push_back(strtoul(itemBuf, &temp, unit));
						}
					}else{
						if(itemBuf[0] != '\0' )
						{
							ulItem.push_back(strtoul(itemBuf, &temp, unit));
													}
					}
				}
				j = 0;
				if( lineBuf[i] == ';' || lineBuf[i] == '#' || lineBuf[i] == '\0') break;
			}else{
				itemBuf[j++] = lineBuf[i];
			}
		}

		if(read_f) // READ R}hs
		{
			read_f = 0;
			if(ulItem.size() != 2) // READ R}hsS
			{
				{
					// debug msg
					char text[512];
					sprintf(text, "Line %d: %s", lineCnt, lineBuf);
					::MessageBoxA(NULL, text, "Error (incomplete READ command)", MB_OK);
				}
				AfxMessageBox(ID_MSG_ERR_INIT);
				goto readfile_end;
			}
			else
			{
				regAddr = ulItem[0];
				ULONG readSize = ulItem[1];
				
				if(readSize == 0)
				{
					char text[512];
					sprintf(text, "Line %d: %s", lineCnt, lineBuf);
					::MessageBoxA(NULL, text, "Error (Read count is 0)", MB_OK);
					AfxMessageBox(ID_MSG_ERR_INIT);
					goto readfile_end;
				}
				else
				{
					BYTE* readBuf = new BYTE[readSize];
					
					bool result = (pMainWnd->m_sviUsbControl).GetValue2(deviceAddr, regAddr, readBuf, readSize, wordMode, TRUE); // 0x08 ͂̒ōs

					if(!result) 
					{
						{
							// debug msg
							char text[512];
							sprintf(text, "Line %d: %s", lineCnt, lineBuf);
							::MessageBoxA(NULL, text, "I2C Read Error", MB_OK);
						}
						AfxMessageBox(ID_MSG_ERR_INIT);
						delete [] readBuf;
						goto readfile_end;
					}
										
					delete [] readBuf;
				}
			}
		}
		else
		{
			// I2CM
			if(ulItem.size() != 0)
			{
				regAddr = ulItem[0];
				if(ulItem.size() > 1)
				{
					BYTE* sendBuf = new BYTE[ulItem.size()-1];
					for(i=1;i<ulItem.size();i++){
						sendBuf[i-1] = (UCHAR)ulItem[i];
					}
					
					if(!(pMainWnd->m_sviUsbControl).SetValue2(deviceAddr, regAddr, sendBuf, ulItem.size()-1, wordMode)) // 0x08 ͂̒ōs
					{
						{
							// debug msg
							char text[512];
							sprintf(text, "Line %d: %s", lineCnt, lineBuf);
							::MessageBoxA(NULL, text, "I2C Write Error", MB_OK);
						}
						AfxMessageBox(ID_MSG_ERR_INIT);
						delete [] sendBuf;
						goto readfile_end;
					}
				}
			}
		}
	}

/*
	pMainWnd->SetDlgItemText(ID_DUMP_VALUE, readValueText);
	// ŏIsɕ\
	CEdit* pEdit = (CEdit*)(pMainWnd->GetDlgItem(ID_DUMP_VALUE));
	pEdit->LineScroll(pEdit->GetLineCount());
	*/
	

readfile_end:
	::PostMessage(pMainWnd->MsgDialog.m_hWnd,WM_CLOSE,0,0);
	if(rcvWorkBuff) delete [] rcvWorkBuff;

	if((pMainWnd->m_sviUsbControl).close() == false){
		AfxMessageBox(ID_MSG_ERR_NO_SVI03);
		goto readfile_end;
	}

	return 0;

}

bool CSVIctlDlg::Checkalnum(LPCTSTR strText,bool cammaflg)
{
	bool rf = false;
	int len = _tcslen(strText);
	for(int i = 0;i<len;i++)
	{
		if(!_istalnum(strText[i]))
		{
			if(!cammaflg)
				return false;
			if(strText[i] != ',' )
				return false;
		}
	}
	return true;
}

void CSVIctlDlg::OnClose()
{
	//AvIinit@CɌۑ

	CIniFileControl iniFile(AppName,IniFileName);

	//	ID_SLAVE_ADDRESS
	CString slaveAddress;
	this->GetDlgItemText(ID_SLAVE_ADDRESS,slaveAddress);
	iniFile.SetString(INI_KEY_SLAVE_ADDRESS,slaveAddress);

	// ID_SUB_ADDRESS
	CString subAddress;
	this->GetDlgItemText(ID_SUB_ADDRESS,subAddress);
	iniFile.SetString(INI_KEY_SUB_ADDRESS,subAddress);

	// ID_VALUE
	CString value;
	this->GetDlgItemText(ID_VALUE,value);
	iniFile.SetString(INI_KEY_VALUE,value);

	// ID_READ_COUNTS
	CString readCounts;
	this->GetDlgItemText(ID_READ_COUNTS,readCounts);
	iniFile.SetString(INI_KEY_READ_COUNTS,readCounts);

	// ID_WORD_ADDRESS
	iniFile.SetInt(INI_KEY_WORD_ADDRESS, m_subAddrType);
	
	CDialog::OnClose();
}

bool CSVIctlDlg::IsBoardSelected()
{
	return true;
}


	
// SVIUSBControl̃|C^擾܂
CSviUsbControl* CSVIctlDlg::GetSviUsbControl(void)
{
	 return &m_sviUsbControl;
}
void CSVIctlDlg::OnBnClickedWordAddress()
{
	m_subAddrType = 1;
	return;
	// debug
	CButton *pCheck = (CButton *)GetDlgItem(ID_WORD_ADDRESS);

	if( pCheck->GetCheck()){
		unsigned char buf[4] = {0x00, 0x00, 0x00, 0x01}; // MSB First
		m_sviUsbControl.SetValue2(0x08, 0x08000018UL, buf, 4, TRUE);
		m_sviUsbControl.SetValue2(0x08, 0x0800001CUL, buf, 4, TRUE);
	}else{
		unsigned char buf[4] = {0x00, 0x00, 0x00, 0x00}; // MSB First
		m_sviUsbControl.SetValue2(0x08, 0x08000018UL, buf, 4, TRUE);
		m_sviUsbControl.SetValue2(0x08, 0x0800001CUL, buf, 4, TRUE);
	}
}

void CSVIctlDlg::OnBnClickedBoardPower()
{
	m_subAddrType = 
	UpdateData();
	// IĂSVI-03{[hݒ肵܂
	if(IsBoardSelected() == false) return;

	if(m_boardPower){
		unsigned char buf[4] = {0x00, 0x00, 0x01, 0x00}; // MSB First
		m_sviUsbControl.SetValue2(0x08, 0x10000000UL, buf, 4, TRUE);
	}else{
		unsigned char buf[4] = {0x00, 0x00, 0x00, 0x00};
		m_sviUsbControl.SetValue2(0x08, 0x10000000UL, buf, 4, TRUE);
	}
}

void CSVIctlDlg::OnBnClickedDebug()
{
	CButton *pCheck = (CButton *)GetDlgItem(ID_Debug);

if( pCheck->GetCheck()){
		unsigned char buf[4] = {0x00, 0x00, 0x00, 0x00}; // MSB First
		m_sviUsbControl.SetValue2(0x08, 0xB0000000UL, buf, 4, TRUE);
	}else{
	unsigned char buf[4] = {0x00, 0x00, 0x00, 0x01}; // MSB First
	m_sviUsbControl.SetValue2(0x08, 0xB0000000UL, buf, 4, TRUE);
	}
}

void CSVIctlDlg::OnBnClickedDebug2()
{
	CButton *pCheck = (CButton *)GetDlgItem(ID_Debug2);

		if( pCheck->GetCheck()){
		unsigned char buf[4] = {0x00, 0x00, 0x00, 0x80}; // MSB First
		m_sviUsbControl.SetValue2(0x08, 0x08000084UL, buf, 4, TRUE);
	}else{
		unsigned char buf[4] = {0x00, 0x00, 0x00, 0x00};
		m_sviUsbControl.SetValue2(0x08, 0x08000084UL, buf, 4, TRUE);
	}
	
}
void CSVIctlDlg::OnBnClickedRestartSvm()
{
	m_sviUsbControl.RestartSVM();

	OnClose();
	EndDialog(0);
}


void CSVIctlDlg::OnBnClickedButton1()
{
	CEdit* pEdit = (CEdit*)GetDlgItem(ID_DUMP_VALUE);
	pEdit->SetWindowTextA("");
}




void CSVIctlDlg::OnBnClickedByteAddress()
{
	m_subAddrType = 0;
}


void CSVIctlDlg::OnBnClickedDwordAddress()
{
	m_subAddrType = 2;
}
