#include "stdafx.h"
#include "SVMSettingInfo.h"
#include "IniFileControl.h"

// [15/05/25] SVIctlDlg.cpp ŕύX
int SVM_03_REVISION; // 0: SVM-03 / 1: SVM-03U
int SVM_MIPI_32B; // [18/07/30]
//int SVM_MIPI_BOARD;

SVMSettingInfo::SVMSettingInfo(void)
{
	// ϐ
	ckin = 0;			
	ckinDiv = 0;		
	color = 0;			
	bt656 = 0;			
	de = 0;				
	edge = 0;			
	hsync = 0;			
	vsync = 0;		
	csSwap = 0;		
#if 1 // 2015.04.17 V1.0.1.0 SVM-03Up1ڒǉ
	csEndian = 0;		
#endif // 2015.04.17 V1.0.1.0 SVM-03Up1ڒǉ
	AppName = "";
	IniFileFullPath = "";

	width = 1280;
	height = 720;
	colorid = 0;
	fps = "30";
	deviceid = 0;
}

SVMSettingInfo::~SVMSettingInfo(void)
{
}

// Rs[RXgN^
SVMSettingInfo::SVMSettingInfo(const SVMSettingInfo &obj)
{
	ckin = obj.ckin;			
	ckinDiv = obj.ckinDiv;		
	color = obj.color;			
	bt656 = obj.bt656;			
	de = obj.de;				
	edge = obj.edge;			
	hsync = obj.hsync;			
	vsync = obj.vsync;		
	csSwap = obj.csSwap;		
#if 1 // 2015.04.17 V1.0.1.0 SVM-03Up1ڒǉ
	csEndian = obj.csEndian;		
#endif // 2015.04.17 V1.0.1.0 SVM-03Up1ڒǉ

	width = obj.width;
	height = obj.height;
	colorid = obj.colorid;
	fps = obj.fps;
	deviceid = obj.deviceid;

	AppName = obj.AppName;
	IniFileFullPath = obj.IniFileFullPath;
}
/**
	@brief	CKIN Out Select擾
	@return	BYTE;CKIN Out Selectݒl
*/
BYTE SVMSettingInfo::GetCkinOutSelect(void)
{
	return ckin;
}
/**
	@brief	CKIN Out Selectݒ
	@param[in] CKIN Out Selectݒl
	@return	Ȃ
*/
void SVMSettingInfo::SetCkinOutSelect(BYTE val)
{
	ckin = val;
}

/**
	@brief	CKIN Out Divide擾
	@return	BYTE;CKIN Out Divideݒl
*/
BYTE SVMSettingInfo::GetCkinOutDivide(void)
{
	return ckinDiv;
}
/**
	@brief	CKIN Out Divideݒ
	@param[in] CKIN Out Divideݒl
	@return	Ȃ
*/
void SVMSettingInfo::SetCkinOutDivide(BYTE val)
{
	ckinDiv = val;
}

/**
	@brief	Color Space Select擾
	@return	BYTE;Color Space Selectݒl
*/
BYTE SVMSettingInfo::GetColorSpaceSelect(void)
{
	return color;
}
/**
	@brief	Color Space Selectݒ
	@param[in] Color Space Selectݒl
	@return	Ȃ
*/
void SVMSettingInfo::SetColorSpaceSelect(BYTE val)
{
	color = val;
}


/**
	@brief	ITU BT.656 Mode(SAV/EAV)擾
	@return	BYTE;ITU BT.656 Mode(SAV/EAV)ݒl
*/
BYTE SVMSettingInfo::GetBT686Mode(void)
{
	return bt656;
}
/**
	@brief	ITU BT.656 Mode(SAV/EAV)ݒ
	@param[in] ITU BT.656 Mode(SAV/EAV)ݒl
	@return	Ȃ
*/
void SVMSettingInfo::SetBT686Mode(BYTE val)
{
	bt656 = val;
}

/**
	@brief	DE Signal Setting擾
	@return	BYTE;DE Signal Settingݒl
*/
BYTE SVMSettingInfo::GetDeSignalSetting(void)
{
	return de;
}
/**
	@brief		DE Signal Settingݒ
	@param[in] 	DE Signal Settingݒl
	@return	Ȃ
*/
void SVMSettingInfo::SetDeSignalSetting(BYTE val)
{
	de = val;
}


/**
	@brief	Polarity of Pixel Clock Edge擾
	@return	BYTE;Polarity of Pixel Clock Edgeݒl
*/
BYTE SVMSettingInfo::GetPolarityClockEdge(void)
{
	return edge;
}
/**
	@brief	Polarity of Pixel Clock Edgeݒ
	@param[in] Polarity of Pixel Clock Edgeݒl
	@return	Ȃ
*/
void SVMSettingInfo::SetPolarityClockEdge(BYTE val)
{
	edge = val;
}

/**
	@brief	Polarity of H-Sync and DE擾
	@return	BYTE;Polarity of H-Sync and DEݒl
*/
BYTE SVMSettingInfo::GetPolarityHsync(void)
{
	return hsync;
}
/**
	@brief	Polarity of H-Sync and DEݒ
	@param[in] Polarity of H-Sync and DEݒl
	@return	Ȃ
*/
void SVMSettingInfo::SetPolarityHsync(BYTE val)
{
	hsync = val;
}

/**
	@brief	Polarity of V-Sync擾
	@return	BYTE;Polarity of V-Syncݒl
*/
BYTE SVMSettingInfo::GetPolarityVsync(void)
{
	return vsync;
}
/**
	@brief	Polarity of V-Syncݒ
	@param[in] Polarity of V-Syncݒl
	@return	Ȃ
*/
void SVMSettingInfo::SetPolarityVsync(BYTE val)
{
	vsync = val;
}

/**
	@brief	CS Swap Mode擾
	@return	BYTE;CS Swap Modeݒl
*/
BYTE SVMSettingInfo::GetCSSwapMode(void)
{
	return csSwap;
}
/**
	@brief	CS Swap Modeݒ
	@param[in] CS Swap Modeݒl
	@return	Ȃ
*/
void SVMSettingInfo::SetCSSwapMode(BYTE val)
{
	csSwap = val;
}

#if 1 // 2015.04.17 V1.0.1.0 SVM-03Up1ڒǉ
/**
	@brief	Endian Mode擾
	@return	BYTE;Endian Modeݒl
*/
BYTE SVMSettingInfo::GetEndianMode(void)
{
	return csEndian;
}
/**
	@brief	Endian Modeݒ
	@param[in] Endian Modeݒl
	@return	Ȃ
*/
void SVMSettingInfo::SetEndianMode(BYTE val)
{
	csEndian = val;
}
#endif // 2015.04.17 V1.0.1.0 SVM-03Up1ڒǉ


int SVMSettingInfo::GetColorGUID(int idx, unsigned char* pGuid, char* name, int nameSize)
{
	if(idx < 0) return -1;

	// Init@C擾
	AppName = AfxGetAppName();
	CString IniFileName = "\\" + AppName + ".ini";
	TCHAR Path[MAX_PATH];
	GetCurrentDirectory(MAX_PATH,Path);
	IniFileName =  Path + IniFileName;
	CIniFileControl iniFile(AppName, IniFileName);

	CString guidString, nameString;

	char buf[128];
	sprintf(buf, "ColorName%d", idx);
	nameString = iniFile.GetString(buf, "");
	sprintf(buf, "ColorGUID%d", idx);
	guidString = iniFile.GetString(buf, "");

	if(nameString == "" || guidString == "") return -2;

	// J}؂ -> char
	buf[0] = '\0';
	int bufPos = 0;
	unsigned char guidBuf[64];
	int guidPos = 0;
	for(int i=0; i<strlen(guidString) + 1; i++){
		char a = guidString[i];
		if(a == ',' || a == '\0'){
//			guidBuf[guidPos++] = (unsigned char) atoi(buf); // dec
			if(buf[0] == '0' && buf[1] == 'x'){
				guidBuf[guidPos++] = (unsigned char) strtol(buf+2, NULL, 16); // hex
			}else{
				guidBuf[guidPos++] = (unsigned char) strtol(buf, NULL, 16); // hex
			}
			bufPos = 0;
		}else{
			buf[bufPos++] = a;
			buf[bufPos]   = '\0';
		}
	}

	if(guidPos != 16) return -3;

	int i;
	for(i=0; i<16; i++) {
		pGuid[i] = guidBuf[i];
	}
	strncpy(name, nameString, nameSize);

	return 0;
}

/**
	@brief	init@C̃tpX擾
	@retval TRUE 
	@retval FALSE s
*/
BOOL SVMSettingInfo::GetIniFilePath(void)
{
	//.svmt@CeKp
	AppName = AfxGetAppName();
	IniFileFullPath = "\\" + AppName + ".svm";

	GetCurrentDirectory(MAX_PATH,AppPath);

	IniFileFullPath =  AppPath + IniFileFullPath;

	return TRUE;

}
/**
	@brief	Init@C̒lNXϐɐݒ
	@retval TRUE 
	@retval FALSE s
*/
BOOL SVMSettingInfo::GetIniFileData(void)
{
	// Init@C擾
	GetIniFilePath();

	// Init@CNX쐬
	CIniFileControl iniFile(AppName, IniFileFullPath);

	// Init@Cl擾
	//	CKIN Out Select
	ckin = iniFile.GetInt(INI_KEY_CKIN,DEFAULT_CKIN);
	//	CKIN Out Divide
	ckinDiv = iniFile.GetInt(INI_KEY_CKINDIV,DEFAULT_CKINDIV);
	//	Color Space Select
	color = iniFile.GetInt(INI_KEY_COLOR,DEFAULT_COLOR);
	//	ITU BT.656 Mode(SAV/EAV)
	bt656 = iniFile.GetInt(INI_KEY_BT656,DEFAULT_BT656);
	//	Polarity of Pixel Clock Edge 
	edge = iniFile.GetInt(INI_KEY_EDGE,DEFAULT_EDGE);
	//	Polarity of H-Sync and DE
	hsync = iniFile.GetInt(INI_KEY_HSYNC,DEFAULT_HSYNC);
	//	Polarity of V-Sync
	vsync = iniFile.GetInt(INI_KEY_VSYNC,DEFAULT_VSYNC);
	//	CS Swap Mode
	csSwap = iniFile.GetInt(INI_KEY_CSSWAP,DEFAULT_CSSWAP);
#if 1 // 2015.04.17 V1.0.1.0 SVM-03/03U؂ւ
	csEndian = iniFile.GetInt(INI_KEY_ENDIAN,DEFAULT_ENDIAN);
#endif // 2015.04.17 V1.0.1.0 SVM-03/03U؂ւ

	width	 = iniFile.GetInt(INI_KEY_WIDTH, DEFAULT_WIDTH);
	height	 = iniFile.GetInt(INI_KEY_HEIGHT, DEFAULT_HEIGHT);
	fps		 = iniFile.GetString(INI_KEY_FPS, DEFAULT_FPS);
	colorid	 = iniFile.GetInt(INI_KEY_COLORGUID, DEFAULT_COLORGUID);

	return TRUE;
}

/**
	@brief	NXϐInit@Cɕۑ
	@retval TRUE 
	@retval FALSE s
*/
BOOL SVMSettingInfo::SetIniFileData(void)
{
	// Init@C擾
	GetIniFilePath();

	// Init@CNX쐬
	CIniFileControl iniFile(AppName,IniFileFullPath);

	// Init@Clݒ
	//	CKIN Out Select
	iniFile.SetInt(INI_KEY_CKIN,ckin);
	//	CKIN Out Divide
	iniFile.SetInt(INI_KEY_CKINDIV,ckinDiv);
	//	Color Space Select
	iniFile.SetInt(INI_KEY_COLOR,color);
	//	ITU BT.656 Mode(SAV/EAV)
	iniFile.SetInt(INI_KEY_BT656,bt656);
	//	Polarity of Pixel Clock Edge 
	iniFile.SetInt(INI_KEY_EDGE,edge);
	//	Polarity of H-Sync and DE
	iniFile.SetInt(INI_KEY_HSYNC,hsync);
	//	Polarity of V-Sync
	iniFile.SetInt(INI_KEY_VSYNC,vsync);
	//	CS Swap Mode
	iniFile.SetInt(INI_KEY_CSSWAP,csSwap);
#if 1 // 2015.04.17 V1.0.1.0 SVM-03/03U؂ւ
	//	Endian Mode
	iniFile.SetInt(INI_KEY_ENDIAN,csEndian);
#endif // 2015.04.17 V1.0.1.0 SVM-03/03U؂ւ

	iniFile.SetInt(INI_KEY_WIDTH, width);
	iniFile.SetInt(INI_KEY_HEIGHT, height);
	iniFile.SetString(INI_KEY_FPS, fps);
	iniFile.SetInt(INI_KEY_COLORGUID, colorid);

	return TRUE;
}